    .set    noreorder
    .set    mips32
    .set    noat
    .text

_start: .global _start

    #
    # SDRAM 64 MB at 0x80000000
    #
    # We set MPORT_PLL, and gate for it
    # then we configure SDRAM with MPORTs registers
    
    # CR_PLL0
    # CPU_PLL     125 MHz 
    # MPORT_PLL   70 MHz
    li $5, 0xb82f4000
    li $6, 0x00008E99
    nop
    sw $6, 0x0($5)

    # CLK_EN
    # All enabled(even reserved places)
    li $5, 0xb82f4004
    li $6, 0xffffffff
    nop
    sw $6, 0x0($5)

    # CR_PLL1
    # ACC OFF
    li $5, 0xb82f407c
    li $6, 0x0000
    nop
    sw $6, 0x0($5)

    #---------------------------------
    # SDRAM memory setup on MC30SF6-em
    # CSCON0
    # CSCON0. CSMASK = 0xf8, CSBA = 0x0
    # Phys addresses 0000_0000 : 07FF_FFFF
    li $5, 0x182f1000
    li $6, 0xb000f8
    nop
    sw $6, 0x0($5)

    # SDRCON
    li $5, 0x182f1014
    li $6, 0x02700020
    nop
    sw $6, 0x0($5)

    # SDRTMR
    li $5, 0x182f1018
    li $6, 0x00740111
    nop
    sw $6, 0x0($5)

    # SDRCSR
    li $5, 0x182f101c
    li $6, 0x40
    nop
    sw $6, 0x0($5)

    # SDRCSR
    li $5, 0x182f101c
    li $6, 0x1
    nop
    sw $6, 0x0($5)
    #---------------------------------

    # jump to spi-boot stage 2
    la      $4, _spi_boot_2_start
    jr      $4
    nop
